VERSION 5.00
Object = "{3B7C8863-D78F-101B-B9B5-04021C009402}#1.2#0"; "richtx32.ocx"
Begin VB.Form frmMain 
   BackColor       =   &H00C0C0C0&
   Caption         =   "Tag Coloring"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer Timer1 
      Interval        =   100
      Left            =   240
      Top             =   240
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Command1"
      Height          =   495
      Left            =   1320
      TabIndex        =   1
      Top             =   120
      Width           =   1935
   End
   Begin RichTextLib.RichTextBox rtf1 
      Height          =   2055
      Left            =   0
      TabIndex        =   0
      Top             =   720
      Width           =   4335
      _ExtentX        =   7646
      _ExtentY        =   3625
      _Version        =   393217
      Enabled         =   -1  'True
      TextRTF         =   $"frmMain.frx":0000
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Const HTML_TEST_FILE  As String = "test.html"

Dim NotChangingKeys() As Integer

Dim CurrentLine As Integer
Dim LineChanged As Boolean
Dim CurrentStart As Integer
Dim CurrentLen As Integer

Private Sub Command1_Click()
    rtf1.LoadFile App.Path & "\" & HTML_TEST_FILE

    Me.MousePointer = vbHourglass

    'Make an initial tag coloring.
    Call ColorTags(0, Len(rtf1.Text), rtf1)

    Me.MousePointer = vbDefault
End Sub

Private Sub Form_Load()
    'Add all of the keys that don't cause the
    'line to change.
    ReDim NotChangingKeys(1 To 17)

    NotChangingKeys(1) = vbKeyShift
    NotChangingKeys(2) = vbKeyControl
    NotChangingKeys(3) = vbKeyMenu
    NotChangingKeys(4) = vbKeyPause
    NotChangingKeys(5) = vbKeyCapital
    NotChangingKeys(6) = vbKeyEscape
    NotChangingKeys(7) = vbKeyPageUp
    NotChangingKeys(8) = vbKeyPageDown
    NotChangingKeys(9) = vbKeyEnd
    NotChangingKeys(10) = vbKeyHome
    NotChangingKeys(11) = vbKeyLeft
    NotChangingKeys(12) = vbKeyUp
    NotChangingKeys(13) = vbKeyRight
    NotChangingKeys(14) = vbKeyDown
    NotChangingKeys(15) = vbKeyPrint
    NotChangingKeys(16) = vbKeyInsert
    NotChangingKeys(17) = vbKeyNumlock
End Sub
Private Sub Form_Resize()
Dim hgt As Single

    hgt = ScaleHeight - rtf1.Top
    If hgt < 120 Then hgt = 120
    rtf1.Move 0, rtf1.Top, ScaleWidth, hgt
End Sub

Private Sub rtf1_KeyDown(KeyCode As Integer, Shift As Integer)
Dim i As Integer, c As Integer, t As Integer
Dim NotChanged As Boolean
Dim n1 As Integer, n2 As Integer
Dim iEnd As Integer, iStart As Integer

    i = InStrRev(rtf1.SelStart + 1, rtf1.Text, "<")
    c = InStrRev(rtf1.SelStart + 1, rtf1.Text, ">")

    If rtf1.SelColor <> vbBlack And _
    Not (i > 0 And c < i) Then
        rtf1.SelColor = vbBlack
    End If

    NotChanged = False
    For t = 1 To UBound(NotChangingKeys)
        If NotChangingKeys(t) = KeyCode And _
        Shift = 0 Then
            NotChanged = True
            Exit For
        ElseIf Shift > 0 And NotChangingKeys(t) = vbKeyShift Or _
        Shift > 0 And NotChangingKeys(t) = vbKeyControl Then
            NotChanged = True
            Exit For
        End If
    Next t

    'shift=2(ctrl)
    If NotChanged = False Or Shift = 1 And _
    KeyCode = vbKeyInsert Or Shift = 1 And _
    KeyCode = vbKeyDelete Or Shift = 2 And _
    KeyCode = vbKeyX Or Shift = 2 And _
    KeyCode = vbKeyV Then
        'When line is changed or when user presses
        'Shift+Insert, Shift+Delete, Ctrl+X,
        'or Ctrl+V.
        LineChanged = True
    End If

    If Shift = 1 And KeyCode = vbKeyInsert Or _
    Shift = 2 And KeyCode = vbKeyV Then
        'User Pasted text.
        rtf1.SelColor = vbBlack

        'See if there are any tags with errors
        'in the previous line.

        'Get the bounds of the previous line.
        iStart = GetFirstLinePos(rtf1.SelStart, _
        CurrentStart, rtf1)
        iEnd = GetLastLinePos(rtf1.SelStart, _
        CurrentStart, rtf1)

        n1 = InStrRev(iStart, rtf1.Text, ">")
        n2 = InStr(iEnd, rtf1.Text, "<")

        If n1 = 0 Then
            n1 = InStrRev(iStart, rtf1.Text, "<") - 1
            If n1 < 0 Then n1 = iStart
        End If
        If n2 = 0 Then
            n2 = InStr(iEnd, rtf1.Text, "<")

            If n2 = 0 Then n2 = iEnd
        End If

        CurrentStart = rtf1.SelStart
        CurrentLen = rtf1.SelLength

        rtf1.SelText = Clipboard.GetText
        n2 = n2 + Len(Clipboard.GetText)

        Call ColorTags(n1, n2, rtf1)

        rtf1.SelStart = CurrentStart + Len(Clipboard.GetText)
        CurrentLine = SendMessage(rtf1.hWnd, EM_LINEFROMCHAR, _
        rtf1.SelStart, 0&)
        rtf1.SelLength = 0

        CurrentLen = 0
        CurrentStart = rtf1.SelStart
        LineChanged = False

        KeyCode = 0
    End If

    If KeyCode = vbKeyBack Then
        If rtf1.SelStart > 0 And rtf1.SelLength = 0 Then
            If Mid(rtf1.Text, rtf1.SelStart, 1) = "<" Or _
            Mid(rtf1.Text, rtf1.SelStart, 1) = ">" Then
                If rtf1.SelStart > 1 Then
                    i = InStrRev(rtf1.SelStart - 1, rtf1.Text, ">")
                Else
                    i = 1
                End If
                c = InStr(rtf1.SelStart + 1, rtf1.Text, "<")

                If i = 0 Then i = 1
                If c = 0 Then c = Len(rtf1.Text)

                n1 = rtf1.SelStart - 1

                rtf1.SelStart = rtf1.SelStart - 1
                rtf1.SelLength = 1
                rtf1.SelText = ""

                Call ColorTags(i - 1, c, rtf1)
                rtf1.SelStart = n1

                KeyCode = 0
            End If
        ElseIf rtf1.SelLength > 0 Then
            If InStr(1, rtf1.SelText, "<") > 0 Or _
            InStr(1, rtf1.SelText, ">") > 0 Then
                If rtf1.SelStart > 1 Then
                    i = InStrRev(rtf1.SelStart - 1, rtf1.Text, ">")
                Else
                    i = 1
                End If
                n1 = rtf1.SelStart
                rtf1.SelText = ""

                c = InStr(rtf1.SelStart + rtf1.SelLength + 1, rtf1.Text, "<")

                If i = 0 Then i = 1
                If c = 0 Then c = Len(rtf1.Text)

                Call ColorTags(i - 1, c, rtf1)
                rtf1.SelStart = n1

                KeyCode = 0
            End If
        End If
    ElseIf KeyCode = vbKeyDelete Or _
     Shift = 2 And KeyCode = vbKeyX Then
        If rtf1.SelLength = 0 Then
            If Mid(rtf1.Text, rtf1.SelStart + 1, 1) = "<" Or _
            Mid(rtf1.Text, rtf1.SelStart + 1, 1) = ">" Then
                If rtf1.SelStart > 1 Then
                    i = InStrRev(rtf1.SelStart, rtf1.Text, ">")
                Else
                    i = 1
                End If
                c = InStr(rtf1.SelStart + 2, rtf1.Text, "<")

                If i = 0 Then i = 1
                If c = 0 Then c = Len(rtf1.Text)

                n1 = rtf1.SelStart

                rtf1.SelLength = 1
                rtf1.SelText = ""

                Call ColorTags(i - 1, c, rtf1)
                rtf1.SelStart = n1

                KeyCode = 0
            End If
        ElseIf rtf1.SelLength > 0 Then
            If InStr(1, rtf1.SelText, "<") > 0 Or _
            InStr(1, rtf1.SelText, ">") > 0 Then
                If rtf1.SelStart > 1 Then
                    i = InStrRev(rtf1.SelStart - 1, rtf1.Text, ">")
                Else
                    i = 1
                End If

                n1 = rtf1.SelStart
                rtf1.SelText = ""

                c = InStr(rtf1.SelStart + rtf1.SelLength + 1, rtf1.Text, "<")

                If i = 0 Then i = 1
                If c = 0 Then c = Len(rtf1.Text)

                Call ColorTags(i - 1, c, rtf1)
                rtf1.SelStart = n1

                KeyCode = 0
            End If
        End If
    End If
End Sub

Private Sub rtf1_KeyPress(KeyAscii As Integer)
Dim i As Integer, c As Integer, t As Integer
Dim num1 As Integer, num2 As Integer
Dim OldStart As Integer, OldLen As Integer
Dim tmp As Long

    LineChanged = True

    If Chr(KeyAscii) = "<" Then
        'Color the "<".
        rtf1.SelColor = vbBlue

        i = InStr(rtf1.SelStart + 1, rtf1.Text, "<")
        c = InStr(rtf1.SelStart + 1, rtf1.Text, ">")

        If c < i Or c > 0 And i = 0 Then
            rtf1.SelText = "<"
            t = rtf1.SelStart
            Call ColorTags(rtf1.SelStart - 1, c, rtf1)
            rtf1.SelStart = t

            KeyAscii = 0
        End If
    ElseIf Chr(KeyAscii) = ">" Then
        i = InStrRev(rtf1.SelStart, rtf1.Text, "<")
        c = InStrRev(rtf1.SelStart, rtf1.Text, ">")

        If c > 0 And c > i Then
            'Color the ">".
            rtf1.SelColor = vbRed
        ElseIf i > 0 And i > c Then
            'Closing tag.
            OldStart = rtf1.SelStart
            rtf1.SelText = ">"
            t = IIf(InStr(i + 1, rtf1.Text, "<"), InStr(i + 1, rtf1.Text, "<"), Len(rtf1.Text))
            Call ColorTags(i - 1, t, rtf1)

            'Paint the text between the tags.

            'Turn refreshing off.
            tmp = LockWindowUpdate(rtf1.hWnd)

            rtf1.SelStart = OldStart + 1
            rtf1.SelLength = t - OldStart - 2
            rtf1.SelColor = vbBlack
            rtf1.SelLength = 0

            'Allow repainting (Refreshing).
            tmp = LockWindowUpdate(0)

            rtf1.SelStart = OldStart + 1

            KeyAscii = 0
        End If
    End If
End Sub

Private Sub Timer1_Timer()
Dim t As Integer
Dim n1 As Integer, n2 As Integer
Dim iEnd As Integer, iStart As Integer

    'Get the line number.
    t = SendMessage(rtf1.hWnd, EM_LINEFROMCHAR, _
    rtf1.SelStart, 0&)

    If CurrentLine <> t And LineChanged = True Then
        'See if there are any tags with errors
        'in the previous line.

        'Get the bounds of the previous line.
        iStart = GetFirstLinePos(CurrentLine, _
        CurrentStart, rtf1)
        iEnd = GetLastLinePos(CurrentLine, _
        CurrentStart, rtf1)

        n1 = InStrRev(iStart, rtf1.Text, ">")
        n2 = InStr(iEnd, rtf1.Text, "<")

        If n1 = 0 Then
            n1 = InStrRev(iStart, rtf1.Text, "<") - 1
            If n1 < 0 Then _
                n1 = iStart
        End If
        If n2 = 0 Then
            n2 = InStr(iEnd, rtf1.Text, "<")

            If n2 = 0 Then _
                n2 = iEnd
        End If

        CurrentStart = rtf1.SelStart
        CurrentLen = rtf1.SelLength

        Call ColorTags(n1, n2, rtf1)

        CurrentLine = t
        rtf1.SelStart = CurrentStart
        rtf1.SelLength = CurrentLen
        LineChanged = False
    End If

    CurrentLine = t
    CurrentStart = rtf1.SelStart
    CurrentLen = rtf1.SelLength
End Sub
